package de.hft.stuttgart.citydoctor2.datastructure;

import de.hft.stuttgart.citydoctor2.utils.CopyHandler;
import de.hft.stuttgart.citydoctor2.utils.Copyable;
import org.citygml4j.core.model.tunnel.TunnelFurnitureProperty;

import java.io.Serial;
import java.util.ArrayList;
import java.util.List;

public class TunnelHollow extends AbstractRoom{
    @Serial
    private static final long serialVersionUID = -276088332165299253L;
    private final List<TunnelFurnitureProperty> furnitureRefs = new ArrayList<>(2);
    private CityObject parent;

    public void setGmlObject(org.citygml4j.core.model.tunnel.HollowSpace gmlHollowSpace){
        super.cgmlRoom = gmlHollowSpace;
    }


    public void setParent(CityObject parent){
        this.parent = parent;
    }

    public void addFurnitureRef(TunnelFurnitureProperty furnitureRef) {
        furnitureRefs.add(furnitureRef);
    }

    public List<TunnelFurnitureProperty> getFurnitureRefs() {
        return furnitureRefs;
    }

    public CityObject getParent() {
        return parent;
    }

    @Override
    public void fillValues(Copyable original, CopyHandler handler){
        super.fillValues(original, handler);

        TunnelHollow oHollow = (TunnelHollow) original;
        parent = handler.getCopyInstance(oHollow.getParent());
    }

    @Override
    public void collectInstances(CopyHandler handler){
        super.collectInstances(handler);
        handler.addInstance(parent);
    }

    @Override
    public Copyable createCopyInstance() {
        return new TunnelHollow();
    }
}
