package de.hft.stuttgart.citydoctor2.datastructure;

import de.hft.stuttgart.citydoctor2.utils.CopyHandler;
import de.hft.stuttgart.citydoctor2.utils.Copyable;

import java.io.Serial;

public class TunnelPart extends AbstractTunnel {

    @Serial
    private static final long serialVersionUID = 8200322261958679163L;

    private Tunnel parent;


    public TunnelPart(Tunnel parent) {
        this.parent = parent;
        parent.addTunnelPart(this);
    }

    public Tunnel getParent() {
        return parent;
    }

    @Override
    public FeatureType getFeatureType() {
        return FeatureType.TUNNEL_PART;
    }

    @Override
    public String toString() {
        return "TunnelPart [id=" + getGmlId() + "]";
    }

    @Override
    public void fillValues(Copyable original, CopyHandler handler) {
        super.fillValues(original, handler);
        TunnelPart originalPart = (TunnelPart) original;
        parent = handler.getCopyInstance(originalPart.parent);
    }

    @Override
    public void collectInstances(CopyHandler handler) {
        super.collectInstances(handler);
        handler.addInstance(parent);
    }

    @Override
    public Copyable createCopyInstance() {
        return new TunnelPart();
    }

    private TunnelPart(){}
}
